// SDB-CGEN V1.8.3
// gcc -DMAIN=1 rnasetup.c ; ./a.out > rnasetup.h
#include <ctype.h>
#include <stdio.h>
#include <string.h>

struct kv { const char *name; const char *value; };
static struct kv kvs[] = {
  {"1","WEP"}, 
  {"2","RNASETUPCALLBACK"}, 
  {"3","INSTALLDEFAULTDRV"}, 
  {NULL, NULL}
};
// 0x579fb000
// TODO
typedef int (*GperfForeachCallback)(void *user, const char *k, const char *v);
int gperf_rnasetup_foreach(GperfForeachCallback cb, void *user) {
  int i = 0; while (kvs[i].name) {
  cb (user, kvs[i].name, kvs[i].value);
  i++;}
  return 0;
}
const char *gperf_rnasetup_get(const char *s) {
  int i = 0; while (kvs[i].name) {
  if (!strcmp (s, kvs[i].name)) return kvs[i].value;
  i++;}
  return NULL;
}
#define sdb_hash_c_rnasetup(x,y) gperf_rnasetup_hash(x)
const unsigned int gperf_rnasetup_hash(const char *s) {
  int sum = strlen (s);
  while (*s) { sum += *s; s++; }
  return sum;
}
struct {const char *name;void *get;void *hash;void *foreach;} gperf_rnasetup = {
  .name = "rnasetup",
  .get = &gperf_rnasetup_get,
  .hash = &gperf_rnasetup_hash,
  .foreach = &gperf_rnasetup_foreach
};

#if MAIN
int main () {
	const char *s = ((char*(*)(char*))gperf_rnasetup.get)("foo");
	printf ("%s\n", s);
}
#endif
